Index: trunk/source/processes/hadronic/cross_sections/src/G4BGGPionElasticXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4BGGPionElasticXS.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4BGGPionElasticXS.cc	(revision 1340)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BGGPionElasticXS.cc,v 1.7 2009/11/19 19:40:45 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4BGGPionElasticXS.cc,v 1.8 2010/10/12 06:03:37 dennis Exp $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 // -------------------------------------------------------------------
@@ -77,20 +77,19 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
-G4double G4BGGPionElasticXS::GetIsoZACrossSection(const G4DynamicParticle* dp, 
-						    G4double Z,
-						    G4double A, 
-						    G4double)
+G4double
+G4BGGPionElasticXS::GetZandACrossSection(const G4DynamicParticle* dp, 
+                                         G4int Z, G4int A, G4double)
 {
   G4double cross = 0.0;
   G4double ekin = dp->GetKineticEnergy();
-  G4int iz = G4int(Z);
-  if(iz > 92) iz = 92;
+//  G4int iz = G4int(Z);
+  if(Z > 92) Z = 92;
 
   if(ekin <= fLowEnergy) {
-    cross = theCoulombFac[iz];
+    cross = theCoulombFac[Z];
     if(isPiplus) { cross *= CoulombFactor(ekin, A); } 
 
-  } else if(iz == 1) {
-    if( A < 1.5) {
+  } else if(Z == 1) {
+    if( A < 2) {
       fHadron->GetHadronNucleonXscNS(dp, G4Proton::Proton());
       cross = fHadron->GetElasticHadronNucleonXsc();
@@ -102,5 +101,5 @@
     }
   } else if(ekin > fGlauberEnergy) {
-    cross = theGlauberFac[iz]*fGlauber->GetElasticGlauberGribov(dp, Z, A);
+    cross = theGlauberFac[Z]*fGlauber->GetElasticGlauberGribov(dp, Z, A);
   } else {
     cross = fPion->GetElasticCrossSection(dp, Z, A);
@@ -159,5 +158,6 @@
   G4NistManager* nist = G4NistManager::Instance();
 
-  G4double A, csup, csdn;
+  G4double csup, csdn;
+  G4int A;
 
   if(verboseLevel > 0) G4cout << "### G4BGGPionElasticXS::Initialise for "
@@ -167,8 +167,8 @@
 
     G4double Z = G4double(iz);
-    A = nist->GetAtomicMassAmu(iz);
-
-    csup = fGlauber->GetElasticGlauberGribov(&dp, Z, A);
-    csdn = fPion->GetElasticCrossSection(&dp, Z, A);
+    A = G4lrint(nist->GetAtomicMassAmu(iz));
+
+    csup = fGlauber->GetElasticGlauberGribov(&dp, iz, A);
+    csdn = fPion->GetElasticCrossSection(&dp, iz, A);
 
     theGlauberFac[iz] = csdn/csup;
@@ -179,12 +179,12 @@
   fHadron->GetHadronNucleonXscNS(&dp, G4Proton::Proton());
   theCoulombFac[1] = fHadron->GetElasticHadronNucleonXsc();
-  if(isPiplus) { theCoulombFac[1] /= CoulombFactor(fLowEnergy,1.0); }
+  if(isPiplus) { theCoulombFac[1] /= CoulombFactor(fLowEnergy,1); }
 
   for(G4int iz=2; iz<93; iz++) {
 
     G4double Z = G4double(iz);
-    A = nist->GetAtomicMassAmu(iz);
-
-    theCoulombFac[iz] = fPion->GetElasticCrossSection(&dp, Z, A);
+    A = G4lrint(nist->GetAtomicMassAmu(iz));
+
+    theCoulombFac[iz] = fPion->GetElasticCrossSection(&dp, iz, A);
     if(isPiplus) { theCoulombFac[iz] /= CoulombFactor(fLowEnergy,A); }
     if(verboseLevel > 0) G4cout << "Z= " << Z <<  "  A= " << A 
@@ -193,27 +193,24 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-G4double G4BGGPionElasticXS::CoulombFactor(G4double kinEnergy, G4double A)
+
+G4double G4BGGPionElasticXS::CoulombFactor(G4double kinEnergy, G4int A)
 {
   G4double res= 0.0;
   if(kinEnergy <= DBL_MIN) return res;
-  else if(A < 1.5) return kinEnergy*kinEnergy;
+  else if(A < 2) return kinEnergy*kinEnergy;
   
   G4double elog = std::log10(kinEnergy/GeV);
+  G4double aa = A;
 
   // from G4ProtonInelasticCrossSection
-  G4double f1 = 8.0  - 8.0/A - 0.008*A;
-  G4double f2 = 2.34 - 5.4/A - 0.0028*A;
+  G4double f1 = 8.0  - 8.0/aa - 0.008*aa;
+  G4double f2 = 2.34 - 5.4/aa - 0.0028*aa;
 
   res = 1.0/(1.0 + std::exp(-f1*(elog + f2)));
  
-  f1 = 5.6 - 0.016*A;
-  f2 = 1.37 + 1.37/A;
-  res *= ( 1.0 + (0.8 + 18./A - 0.002*A)/(1.0 + std::exp(f1*(elog + f2))));
+  f1 = 5.6 - 0.016*aa;
+  f2 = 1.37 + 1.37/aa;
+  res *= ( 1.0 + (0.8 + 18./aa - 0.002*aa)/(1.0 + std::exp(f1*(elog + f2))));
   return res;  
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-
Index: trunk/source/processes/hadronic/cross_sections/src/G4BGGPionInelasticXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4BGGPionInelasticXS.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4BGGPionInelasticXS.cc	(revision 1340)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BGGPionInelasticXS.cc,v 1.8 2009/11/19 19:40:45 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4BGGPionInelasticXS.cc,v 1.9 2010/10/12 06:03:49 dennis Exp $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 // -------------------------------------------------------------------
@@ -77,21 +77,20 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
-G4double G4BGGPionInelasticXS::GetIsoZACrossSection(const G4DynamicParticle* dp, 
-						    G4double Z,
-						    G4double A, 
-						    G4double)
+G4double
+G4BGGPionInelasticXS::GetZandACrossSection(const G4DynamicParticle* dp, 
+                                           G4int Z, G4int A, G4double)
 {
   G4double cross = 0.0;
   G4double ekin = dp->GetKineticEnergy();
-  G4int iz = G4int(Z);
-  if(iz > 92) iz = 92;
+//  G4int iz = G4int(Z);
+  if(Z > 92) Z = 92;
 
   if(ekin <= fLowEnergy) {
-    cross = theCoulombFac[iz];
+    cross = theCoulombFac[Z];
     if(isPiplus) { cross *= CoulombFactor(ekin, A); } 
 
-  } else if(iz == 1) {
-
-    if( A < 1.5) {
+  } else if(Z == 1) {
+
+    if( A < 2) {
       fHadron->GetHadronNucleonXscNS(dp, G4Proton::Proton());
       cross = fHadron->GetInelasticHadronNucleonXsc();
@@ -104,5 +103,5 @@
 
   } else if(ekin > fGlauberEnergy) {
-    cross = theGlauberFac[iz]*fGlauber->GetInelasticGlauberGribov(dp, Z, A);
+    cross = theGlauberFac[Z]*fGlauber->GetInelasticGlauberGribov(dp, Z, A);
 
   } else {
@@ -162,5 +161,6 @@
   G4NistManager* nist = G4NistManager::Instance();
 
-  G4double A, csup, csdn;
+  G4double csup, csdn;
+  G4int A;
 
   if(verboseLevel > 0) G4cout << "### G4BGGPionInelasticXS::Initialise for "
@@ -172,8 +172,8 @@
 
     G4double Z = G4double(iz);
-    A = nist->GetAtomicMassAmu(iz);
-
-    csup = fGlauber->GetInelasticGlauberGribov(&dp, Z, A);
-    csdn = fPion->GetInelasticCrossSection(&dp, Z, A);
+    A = G4lrint(nist->GetAtomicMassAmu(iz));
+
+    csup = fGlauber->GetInelasticGlauberGribov(&dp, iz, A);
+    csdn = fPion->GetInelasticCrossSection(&dp, iz, A);
 
     theGlauberFac[iz] = csdn/csup;
@@ -184,12 +184,12 @@
   fHadron->GetHadronNucleonXscNS(&dp, G4Proton::Proton());
   theCoulombFac[1] = fHadron->GetInelasticHadronNucleonXsc();
-  if(isPiplus) { theCoulombFac[1] /= CoulombFactor(fLowEnergy,1.0); }
+  if(isPiplus) { theCoulombFac[1] /= CoulombFactor(fLowEnergy,1); }
      
   for(G4int iz=2; iz<93; iz++) {
 
     G4double Z = G4double(iz);
-    A = nist->GetAtomicMassAmu(iz);
-
-    theCoulombFac[iz] = fPion->GetIsoZACrossSection(&dp, Z, A);
+    A = G4lrint(nist->GetAtomicMassAmu(iz));
+
+    theCoulombFac[iz] = fPion->GetIsoZACrossSection(&dp, iz, A);
     if(isPiplus) { theCoulombFac[iz] /= CoulombFactor(fLowEnergy,A); }
 
@@ -199,27 +199,25 @@
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-G4double G4BGGPionInelasticXS::CoulombFactor(G4double kinEnergy, G4double A)
+
+G4double G4BGGPionInelasticXS::CoulombFactor(G4double kinEnergy, G4int A)
 {
   G4double res= 0.0;
   if(kinEnergy <= DBL_MIN) return res;
-  else if(A < 1.5) return kinEnergy*kinEnergy;
+  else if(A < 2) return kinEnergy*kinEnergy;
   
   G4double elog = std::log10(kinEnergy/GeV);
+  G4double aa = A;
 
   // from G4ProtonInelasticCrossSection
-  G4double f1 = 8.0  - 8.0/A - 0.008*A;
-  G4double f2 = 2.34 - 5.4/A - 0.0028*A;
+  G4double f1 = 8.0  - 8.0/aa - 0.008*aa;
+  G4double f2 = 2.34 - 5.4/aa - 0.0028*aa;
 
   res = 1.0/(1.0 + std::exp(-f1*(elog + f2)));
  
-  f1 = 5.6 - 0.016*A;
-  f2 = 1.37 + 1.37/A;
-  res *= ( 1.0 + (0.8 + 18./A - 0.002*A)/(1.0 + std::exp(f1*(elog + f2))));
+  f1 = 5.6 - 0.016*aa;
+  f2 = 1.37 + 1.37/aa;
+  res *= ( 1.0 + (0.8 + 18./aa - 0.002*aa)/(1.0 + std::exp(f1*(elog + f2))));
   return res;  
 }
 
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-
+
Index: trunk/source/processes/hadronic/cross_sections/src/G4EMDissociationCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4EMDissociationCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4EMDissociationCrossSection.cc	(revision 1340)
@@ -34,5 +34,5 @@
 // ********************************************************************
 //
-// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 //
 // MODULE:		G4EMDissociationCrossSection.cc
@@ -45,5 +45,5 @@
 // Contract:		17191/03/NL/LvH
 //
-// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 //
 // CHANGE HISTORY
@@ -56,8 +56,9 @@
 // Beta release
 //
-// 30. May 2005, J.P. Wellisch removed a compilation warning on gcc 3.4 for gant4 7.1.
-//
-// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-////////////////////////////////////////////////////////////////////////////////
+// 30. May 2005, J.P. Wellisch removed a compilation warning on gcc 3.4 for 
+//               geant4 7.1.
+//
+// %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+//////////////////////////////////////////////////////////////////////////////
 //
 #include "G4EMDissociationCrossSection.hh"
@@ -65,10 +66,10 @@
 #include "G4ParticleTable.hh"
 #include "G4IonTable.hh"
+#include "G4HadTmpUtil.hh"
 #include "globals.hh"
-////////////////////////////////////////////////////////////////////////////////
-//
+
+
 G4EMDissociationCrossSection::G4EMDissociationCrossSection ()
 {
-//
 //
 // This function makes use of the class which can sample the virtual photon
@@ -86,5 +87,5 @@
   xd      = 0.25;
 }
-////////////////////////////////////////////////////////////////////////////////
+//////////////////////////////////////////////////////////////////////////////
 //
 G4EMDissociationCrossSection::~G4EMDissociationCrossSection()
@@ -92,8 +93,9 @@
   delete thePhotonSpectrum;
 }
-///////////////////////////////////////////////////////////////////////////////
-//
-G4bool G4EMDissociationCrossSection::IsZAApplicable
-(const G4DynamicParticle* theDynamicParticle, G4double /*ZZ*/, G4double AA)
+/////////////////////////////////////////////////////////////////////////////
+//
+G4bool
+G4EMDissociationCrossSection::IsIsoApplicable(const G4DynamicParticle* theDynamicParticle,
+                                              G4int /*ZZ*/, G4int AA)
 {
 //
@@ -105,5 +107,5 @@
 //
   if (G4ParticleTable::GetParticleTable()->GetIonTable()->
-    IsIon(theDynamicParticle->GetDefinition()) && AA > 1.0)
+    IsIon(theDynamicParticle->GetDefinition()) && AA > 1)
     return true;
   else
@@ -114,5 +116,5 @@
   (const G4DynamicParticle* theDynamicParticle, const G4Element* theElement)
 {
-  return IsZAApplicable(theDynamicParticle, 0., theElement->GetN());
+  return IsIsoApplicable(theDynamicParticle, 0, G4lrint(theElement->GetN()));
 }
 
@@ -130,18 +132,18 @@
     G4IsotopeVector* isoVector = theElement->GetIsotopeVector();
     G4double* abundVector = theElement->GetRelativeAbundanceVector();
-    G4double ZZ;
-    G4double AA;
+    G4int ZZ;
+    G4int AA;
      
     for (G4int i = 0; i < nIso; i++) {
-      ZZ = G4double( (*isoVector)[i]->GetZ() );
-      AA = G4double( (*isoVector)[i]->GetN() );
-      sig = GetIsoZACrossSection(theDynamicParticle, ZZ, AA, temperature);
+      ZZ = (*isoVector)[i]->GetZ();
+      AA = (*isoVector)[i]->GetN();
+      sig = GetZandACrossSection(theDynamicParticle, ZZ, AA, temperature);
       crossSection += sig*abundVector[i];
     }
    
   } else {
-    crossSection =
-      GetIsoZACrossSection(theDynamicParticle, theElement->GetZ(), 
-                           theElement->GetN(), temperature);
+    G4int ZZ = G4lrint(theElement->GetZ());
+    G4int AA = G4lrint(theElement->GetN());
+    crossSection = GetZandACrossSection(theDynamicParticle, ZZ, AA, temperature);
   }
     
@@ -150,9 +152,8 @@
 
 
-G4double G4EMDissociationCrossSection::GetIsoZACrossSection
-  (const G4DynamicParticle *theDynamicParticle, G4double ZZ, G4double AA,
-   G4double /*temperature*/)
-{
-//
+G4double
+G4EMDissociationCrossSection::GetZandACrossSection(const G4DynamicParticle *theDynamicParticle,
+                                                   G4int ZZ, G4int AA, G4double /*temperature*/)
+{
 //
 // Get relevant information about the projectile and target (A, Z) and
@@ -240,4 +241,5 @@
   return theCrossSectionVector;
 }
+
 ////////////////////////////////////////////////////////////////////////////////
 //
@@ -247,5 +249,4 @@
 {
 //
-//
 // This is a cheaky little member function to calculate the probability of
 // EMD for the target in the field of the projectile ... just by reversing the
@@ -254,11 +255,10 @@
   return GetCrossSectionForProjectile (AT, ZT, AP, ZP, b, bmin);
 }
-////////////////////////////////////////////////////////////////////////////////
-//
+
+
 G4double
-  G4EMDissociationCrossSection::GetWilsonProbabilityForProtonDissociation
-  (G4double A, G4double Z)
-{
-//
+G4EMDissociationCrossSection::GetWilsonProbabilityForProtonDissociation(G4double A,
+                                                                        G4double Z)
+{
 //
 // This is a simple algorithm to choose whether a proton or neutron is ejected
@@ -282,4 +282,2 @@
   return p;
 }
-////////////////////////////////////////////////////////////////////////////////
-//
Index: trunk/source/processes/hadronic/cross_sections/src/G4ElectroNuclearCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4ElectroNuclearCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4ElectroNuclearCrossSection.cc	(revision 1340)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4ElectroNuclearCrossSection.cc,v 1.29 2008/10/24 19:15:17 dennis Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4ElectroNuclearCrossSection.cc,v 1.30 2010/10/14 05:25:22 dennis Exp $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 //
@@ -33,5 +33,5 @@
 // The last update: M.V. Kossov, CERN/ITEP (Moscow) 17-Oct-03
 // 
-//===============================================================================================
+//============================================================================
 
 ///#define debug
@@ -43,9 +43,16 @@
 
 #include "G4ElectroNuclearCrossSection.hh"
+#include "G4HadTmpUtil.hh"
 
 // Initialization of statics
-G4double  G4ElectroNuclearCrossSection::lastE=0.;  // Last used in the cross section TheEnergy
-G4int     G4ElectroNuclearCrossSection::lastF=0;   // Last used in the cross section TheFirstBin
-G4double  G4ElectroNuclearCrossSection::lastG=0.;  // Last used in the cross section TheGamma
+// Last used in the cross section TheEnergy
+G4double G4ElectroNuclearCrossSection::lastE=0.;
+
+// Last used in the cross section TheFirstBin
+G4int G4ElectroNuclearCrossSection::lastF=0;
+
+// Last used in the cross section TheGamma
+G4double G4ElectroNuclearCrossSection::lastG=0.;
+
 G4double  G4ElectroNuclearCrossSection::lastH=0.;  // Last value of the High Energy A-dependence
 G4double* G4ElectroNuclearCrossSection::lastJ1=0;  // Pointer to the last array of the J1 function
@@ -58,11 +65,17 @@
 G4double  G4ElectroNuclearCrossSection::lastSig=0.;// Last value of the Cross Section
 
-std::vector<G4double*> G4ElectroNuclearCrossSection::J1;     // Vector of pointers to the J1 tabulated functions
-std::vector<G4double*> G4ElectroNuclearCrossSection::J2;     // Vector of pointers to the J2 tabulated functions
-std::vector<G4double*> G4ElectroNuclearCrossSection::J3;     // Vector of pointers to the J3 tabulated functions
+// Vector of pointers to the J1 tabulated functions
+std::vector<G4double*> G4ElectroNuclearCrossSection::J1;
+
+// Vector of pointers to the J2 tabulated functions
+std::vector<G4double*> G4ElectroNuclearCrossSection::J2;
+
+// Vector of pointers to the J3 tabulated functions
+std::vector<G4double*> G4ElectroNuclearCrossSection::J3;
+
 
 G4ElectroNuclearCrossSection::G4ElectroNuclearCrossSection()
-{
-}
+{}
+
 
 G4ElectroNuclearCrossSection::~G4ElectroNuclearCrossSection()
@@ -95,11 +108,11 @@
     G4IsotopeVector* isoVector = anEle->GetIsotopeVector();
     G4double* abundVector = anEle->GetRelativeAbundanceVector();
-    G4double ZZ;
-    G4double AA;
+    G4int ZZ;
+    G4int AA;
      
     for (G4int i = 0; i < nIso; i++) {
-      ZZ = G4double( (*isoVector)[i]->GetZ() );
-      AA = G4double( (*isoVector)[i]->GetN() );
-      sig = GetIsoZACrossSection(aPart, ZZ, AA, temperature);
+      ZZ = (*isoVector)[i]->GetZ();
+      AA = (*isoVector)[i]->GetN();
+      sig = GetZandACrossSection(aPart, ZZ, AA, temperature);
       xsection += sig*abundVector[i];
     }
@@ -107,5 +120,7 @@
   } else {
     xsection =
-      GetIsoZACrossSection(aPart, anEle->GetZ(), anEle->GetN(),
+      GetZandACrossSection(aPart,
+                           G4lrint(anEle->GetZ()),
+                           G4lrint(anEle->GetN()),
                            temperature);
   }
@@ -116,14 +131,14 @@
 
 G4double 
-G4ElectroNuclearCrossSection::GetIsoZACrossSection(const G4DynamicParticle* aPart,
-                                              G4double ZZ, G4double AA,
-					      G4double /*temperature*/)
+G4ElectroNuclearCrossSection::GetZandACrossSection(const G4DynamicParticle* aPart,
+                                                   G4int ZZ, G4int AA,
+					           G4double /*temperature*/)
 {
   static const G4int nE=336; // !!  If you change this, change it in GetFunctions() (*.hh) !!
   static const G4int mL=nE-1;
-  static const G4double EMi=2.0612;          // Minimum tabulated Energy of the Electron
-  static const G4double EMa=50000.;          // Maximum tabulated Energy of the Electron 
-  static const G4double lEMi=std::log(EMi);       // Minimum tabulated logarithmic Energy of the Electron
-  static const G4double lEMa=std::log(EMa);       // Maximum tabulated logarithmic Energy of the Electron
+  static const G4double EMi=2.0612; // Minimum tabulated Energy of the Electron
+  static const G4double EMa=50000.; // Maximum tabulated Energy of the Electron
+  static const G4double lEMi=std::log(EMi);  // Minimum tabulated logarithmic Energy of the Electron
+  static const G4double lEMa=std::log(EMa);  // Maximum tabulated logarithmic Energy of the Electron
   static const G4double dlnE=(lEMa-lEMi)/mL; // Logarithmic step in the table for the electron Energy
   static const G4double alop=1./137.036/3.14159265; //coef. for the calculated functions (Ee>50000.)
@@ -137,14 +152,16 @@
   static std::vector <G4double> colH;    // Vector of HighEnergyCoefficients (functional calculations)
   // *** End of Static Definitions (Associative Memory) ***
+
   const G4double Energy = aPart->GetKineticEnergy()/MeV; // Energy of the electron
-  const G4int targetAtomicNumber = static_cast<int>(AA+.499); //@@ Nat mixture (?!)
-  const G4int targZ = static_cast<int>(ZZ+.001);
+  const G4int targetAtomicNumber = AA;
+  const G4int targZ = ZZ;
   const G4int targN = targetAtomicNumber-targZ; // @@ Get isotops (can change initial A)
   if (Energy<=EMi) return 0.;              // Energy is below the minimum energy in the table
+
   G4int PDG=aPart->GetDefinition()->GetPDGEncoding();
-  if(  PDG == 11 || PDG == -11)            // @@ Now only for electrons, but can be fo muons
+  if (PDG == 11 || PDG == -11)            // @@ Now only for electrons, but can be fo muons
   {
-    G4double A=targN+targZ;                // New A (can differ from G4double targetAtomicNumber)
-    if(targN!=lastN || targZ!=lastZ)       // This nucleus was not the last used isotop
+    G4double A = targN + targZ;           // New A (can differ from G4double targetAtomicNumber)
+    if(targN!=lastN || targZ!=lastZ)      // This nucleus was not the last used isotop
 	{
       lastE    = 0.;                       // New history in the electron Energy
@@ -185,4 +202,5 @@
 	  } // End of creation of the new set of parameters
     } // End of parameters udate
+
     else if(std::abs((lastE-Energy)/Energy)<.001) return lastSig*millibarn; // Don't calc. same CS twice
     // ============================== NOW Calculate the Cross Section ==========================
@@ -268,22 +286,4 @@
 }
 
-// Correction function for Be,C @@ Move to header // @@@ !!! NOT used !!!
-//G4double G4ElectroNuclearCrossSection::LinearFit(G4double X, G4int N, const G4double* XN,
-//                                                 const G4double* YN)
-//{
-//  G4double Xj=XN[0];
-//  G4double Xh=XN[N-1];
-//  if(X<=Xj) return YN[0]; //-------+ !!! If you correct this, correct upper copy too!!
-//  else if(X>=Xh) return YN[N-1];//-|
-//  G4double Xp=0.; //               |
-//  G4int j=0;   //                  |
-//  while (X>Xj && j<N)//<-----------+
-//  {
-//    j++;
-//    Xp=Xj;
-//    Xj=XN[j];
-//  }
-//  return YN[j]-(Xj-X)*(YN[j]-YN[j-1])/(Xj-Xp);
-//}
 
 // Calculate the functions for the std::log(A)
